unit UPRINCIPAL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WinTypes,  WinProcs;


type
  TForm1 = class(TForm)
    EDT_DIRETORIO: TEdit;
    Label1: TLabel;
    BTN_DIRETORIO: TButton;
    OPD: TOpenDialog;
    CKB_EXE: TCheckBox;
    CKB_BCK: TCheckBox;
    ListBox1: TListBox;
    LBL_LISTADOS: TLabel;
    ckb_dcu: TCheckBox;
    btn_limpar: TButton;
    Label3: TLabel;
    Memo1: TMemo;
    procedure BTN_DIRETORIOClick(Sender: TObject);
    procedure btn_limparClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
     Function LogFiles( Const path: String; Const SRec: TSearchRec ): Boolean;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

USes DirScan;


procedure TForm1.BTN_DIRETORIOClick(Sender: TObject);
VAR
PERMISSAO  : INTEGER;
CAMINHO :STRING;
begin
    OPD.Execute;
    CAMINHO            := ExtractFilePath(OPD.FileName);
    EDT_DIRETORIO.Text :=  CAMINHO;

    MEMO1.Lines.Clear;
    ListBox1.Clear;

    PERMISSAO :=1 ;

    IF Length (TRIM (CAMINHO)) = 3  THEN
    BEGIN
     ShowMessage('NAO PODE EXCLUIR DA RAIZ');
     PERMISSAO := 0;
    END;

    IF COPY (CAMINHO,4,7) = 'WINDOWS'  THEN
    BEGIN
     ShowMessage('DIRETORIO DO SISTEMA OPERACIONAL');
     PERMISSAO := 0;
    END;

    IF PERMISSAO = 1 THEN
    BEGIN // LISTA
        Screen.Cursor := crHourGlass;
        ListBox1.Clear;
        Listbox1.Perform( WM_SETREDRAW, 0, 0 );

        IF CKB_EXE.Checked = TRUE THEN
           FindRecursive( EDT_DIRETORIO.Text, '*.EXE', LogFiles );

        IF CKB_BCK.Checked = TRUE THEN
           FindRecursive( EDT_DIRETORIO.Text, '*.~*', LogFiles );

          IF CKB_EXE.Checked = TRUE THEN
           FindRecursive( EDT_DIRETORIO.Text, '*.dcu', LogFiles );

        Listbox1.Perform( WM_SETREDRAW, 1, 0 );
        Listbox1.Refresh;
        Screen.Cursor := crDefault;
   END;
   If ListBox1.Items.Count = 0 Then
   BEGIN
       MessageDlg('Nenhum arquivo foi encontrado', mtInformation, [mbOK], 0);
       btn_limpar.Visible := FALSE
    END
    ELSE
         btn_limpar.Visible := TRUE;


   LBL_LISTADOS.Caption := 'LISTADOS : ' + INTTOSTR (ListBox1.Items.Count);
end;

function TForm1.LogFiles(const path: String;
  const SRec: TSearchRec): Boolean;
begin
      Listbox1.Items.Add( path+SRec.Name );
    Result := True;   (* proceeed with recursion *)

end;

procedure TForm1.btn_limparClick(Sender: TObject);
VAR
CONT, QTD_APAGADOS :WORD;
ARQUIVO :STRING;
begin
  if ListBox1.Items.Count >0 then
  begin
     QTD_APAGADOS := 0;
      FOR  CONT :=0 TO ListBox1.Items.Count - 1 DO
      BEGIN
      ARQUIVO := ListBox1.Items[CONT];
      IF DeleteFile(PCHAR (ARQUIVO)) = FALSE THEN
         Memo1.LINES.ADD (ARQUIVO)
      ELSE
      QTD_APAGADOS := QTD_APAGADOS + 1;
      END;

      ShowMessage(INTTOSTR (QTD_APAGADOS) + ' ARQUIVOS APAGADOS');
 end;

end;

procedure TForm1.FormShow(Sender: TObject);
begin
self.Left := (screen.Width -  self.Width) div 2;
self.top := (screen.Height -  self.Height- 30) div 2;
end;

end.
